Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.beans
Class VetoableChangeSupport

    java.lang.Object
      java.beans.VetoableChangeSupport

All Implemented Interfaces:
  Serializable

    public class VetoableChangeSupport

extends Object
implements Serializable

This is a utility class that can be used by beans that support constrained properties. You can use an instance of this class as a member field of your bean and delegate various work to it. This class is serializable. When it is serialized it will save (and restore) any listeners that are themselves serializable. Any non-serializable listeners will be skipped during serialization.

See Also:
  Serialized Form

Constructor Summary
`VetoableChangeSupport(Object sourceBean)` Constructs a `VetoableChangeSupport` object.

Method Summary
`void` | `addVetoableChangeListener(String propertyName, VetoableChangeListener listener)` Add a VetoableChangeListener for a specific property.
`void` | `addVetoableChangeListener(VetoableChangeListener listener)` Add a VetoableListener to the listener list.
`void` | `fireVetoableChange(PropertyChangeEvent evt)` Fire a vetoable property update to any registered listeners.
`void` | `fireVetoableChange(String propertyName, boolean oldValue, boolean newValue)` Report a boolean vetoable property update to any registered listeners.
`void` | `fireVetoableChange(String propertyName, int oldValue, int newValue)` Report a int vetoable property update to any registered listeners.
`void` | `fireVetoableChange(String propertyName, Object oldValue, Object newValue)` Report a vetoable property update to any registered listeners.
`VetoableChangeListener[]` | `getVetoableChangeListeners()` Returns the list of VetoableChangeListeners.
`VetoableChangeListener[]` | `getVetoableChangeListeners(String propertyName)` Returns an array of all the listeners which have been associated with the named property.
`boolean` | `hasListeners(String propertyName)` Check if there are any listeners for a specific property, including those registered on all properties.
`void` | `removeVetoableChangeListener(String propertyName, VetoableChangeListener listener)` Remove a VetoableChangeListener for a specific property.
`void` | `removeVetoableChangeListener(VetoableChangeListener listener)` Remove a VetoableChangeListener from the listener list.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### VetoableChangeSupport

    public VetoableChangeSupport(Object sourceBean)

  Constructs a `VetoableChangeSupport` object.

  Parameters:
    `sourceBean` - The bean to be given as the source for any events.

Method Detail

### addVetoableChangeListener

    public void addVetoableChangeListener(VetoableChangeListener listener)

  Add a VetoableListener to the listener list. The listener is registered for all properties. The same listener object may be added more than once, and will be called as many times as it is added. If `listener` is null, no exception is thrown and no action is taken.

  Parameters:
    `listener` - The VetoableChangeListener to be added

### removeVetoableChangeListener

    public void removeVetoableChangeListener(VetoableChangeListener listener)

  Remove a VetoableChangeListener from the listener list. This removes a VetoableChangeListener that was registered for all properties. If `listener` was added more than once to the same event source, it will be notified one less time after being removed. If `listener` is null, or was never added, no exception is thrown and no action is taken.

  Parameters:
    `listener` - The VetoableChangeListener to be removed

### getVetoableChangeListeners

    public VetoableChangeListener[] getVetoableChangeListeners()

  Returns the list of VetoableChangeListeners. If named vetoable change listeners were added, then VetoableChangeListenerProxy wrappers will returned

  Returns:
    List of VetoableChangeListeners and VetoableChangeListenerProxys if named property change listeners were added.
  Since:
    1.4

### addVetoableChangeListener

    public void addVetoableChangeListener(String propertyName,
                                          VetoableChangeListener listener)

  Add a VetoableChangeListener for a specific property. The listener will be invoked only when a call on fireVetoableChange names that specific property. The same listener object may be added more than once. For each property, the listener will be invoked the number of times it was added for that property. If `propertyName` or `listener` is null, no exception is thrown and no action is taken.

  Parameters:
    `propertyName` - The name of the property to listen on.
    `listener` - The VetoableChangeListener to be added

### removeVetoableChangeListener

    public void removeVetoableChangeListener(String propertyName,
                                             VetoableChangeListener listener)

  Remove a VetoableChangeListener for a specific property. If `listener` was added more than once to the same event source for the specified property, it will be notified one less time after being removed. If `propertyName` is null, no exception is thrown and no action is taken. If `listener` is null, or was never added for the specified property, no exception is thrown and no action is taken.

  Parameters:
    `propertyName` - The name of the property that was listened on.
    `listener` - The VetoableChangeListener to be removed

### getVetoableChangeListeners

    public VetoableChangeListener[] getVetoableChangeListeners(String propertyName)

  Returns an array of all the listeners which have been associated with the named property.

  Parameters:
    `propertyName` - The name of the property being listened to
  Returns:
    all the `VetoableChangeListeners` associated with the named property. If no such listeners have been added, or if `propertyName` is null, an empty array is returned.

### fireVetoableChange

    public void fireVetoableChange(String propertyName,
                                   Object oldValue,
                                   Object newValue)
                            throws PropertyVetoException

  Report a vetoable property update to any registered listeners. If anyone vetos the change, then fire a new event reverting everyone to the old value and then rethrow the PropertyVetoException.

  No event is fired if old and new are equal and non-null.

  Parameters:
    `propertyName` - The programmatic name of the property that is about to change..
    `oldValue` - The old value of the property.
    `newValue` - The new value of the property.
  Throws:
    `PropertyVetoException` - if the recipient wishes the property change to be rolled back.

### fireVetoableChange

    public void fireVetoableChange(String propertyName,
                                   int oldValue,
                                   int newValue)
                            throws PropertyVetoException

  Report a int vetoable property update to any registered listeners. No event is fired if old and new are equal and non-null.

  This is merely a convenience wrapper around the more general fireVetoableChange method that takes Object values.

  Parameters:
    `propertyName` - The programmatic name of the property that is about to change.
    `oldValue` - The old value of the property.
    `newValue` - The new value of the property.
  Throws:
    `PropertyVetoException`

### fireVetoableChange

    public void fireVetoableChange(String propertyName,
                                   boolean oldValue,
                                   boolean newValue)
                            throws PropertyVetoException

  Report a boolean vetoable property update to any registered listeners. No event is fired if old and new are equal and non-null.

  This is merely a convenience wrapper around the more general fireVetoableChange method that takes Object values.

  Parameters:
    `propertyName` - The programmatic name of the property that is about to change.
    `oldValue` - The old value of the property.
    `newValue` - The new value of the property.
  Throws:
    `PropertyVetoException`

### fireVetoableChange

    public void fireVetoableChange(PropertyChangeEvent evt)
                            throws PropertyVetoException

  Fire a vetoable property update to any registered listeners. If anyone vetos the change, then fire a new event reverting everyone to the old value and then rethrow the PropertyVetoException.

  No event is fired if old and new are equal and non-null.

  Parameters:
    `evt` - The PropertyChangeEvent to be fired.
  Throws:
    `PropertyVetoException` - if the recipient wishes the property change to be rolled back.

### hasListeners

    public boolean hasListeners(String propertyName)

  Check if there are any listeners for a specific property, including those registered on all properties. If `propertyName` is null, only check for listeners registered on all properties.

  Parameters:
    `propertyName` - the property name.
  Returns:
    true if there are one or more listeners for the given property

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.